Index: src/atom_graphnodeinfo.cpp
===================================================================
--- src/atom_graphnodeinfo.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/atom_graphnodeinfo.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,12 +6,23 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
 #include "atom_graphnodeinfo.hpp"
-#include "memoryallocator.hpp"
 
 /** Constructor of class GraphNodeInfo.
  */
-GraphNodeInfo::GraphNodeInfo() : GraphNr(-1), ComponentNr(NULL), LowpointNr(-1), SeparationVertex(false), IsCyclic(false), Ancestor(NULL) {};
+GraphNodeInfo::GraphNodeInfo() :
+  GraphNr(-1),
+  ComponentNr(0),
+  LowpointNr(-1),
+  SeparationVertex(false),
+  IsCyclic(false),
+  Ancestor(0)
+{};
 
 /** Destructor of class GraphNodeInfo.
Index: src/atom_graphnodeinfo.hpp
===================================================================
--- src/atom_graphnodeinfo.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/atom_graphnodeinfo.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -37,5 +37,5 @@
 
   GraphNodeInfo();
-  ~GraphNodeInfo();
+  virtual ~GraphNodeInfo();
 private:
 
Index: src/atom_particleinfo.cpp
===================================================================
--- src/atom_particleinfo.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/atom_particleinfo.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,18 +6,26 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
 #include "atom_particleinfo.hpp"
-#include "memoryallocator.hpp"
+
+#include <iostream>
 
 /** Constructor of ParticleInfo.
  */
-ParticleInfo::ParticleInfo() : nr(-1), name("Unknown") {
-};
+ParticleInfo::ParticleInfo() :
+  nr(-1),
+  name("Unknown")
+{};
 
 ParticleInfo::ParticleInfo(ParticleInfo *pointer) :
-    nr(pointer->nr),
-    name(pointer->name)
-    {}
+  nr(pointer->nr),
+  name(pointer->name)
+{}
 
 
@@ -37,5 +45,5 @@
 ostream & operator << (ostream &ost, const ParticleInfo &a)
 {
-  ost << "[" << a.getName() << "|" << &a << "]";
+  ost << a.getName();
   return ost;
 };
@@ -43,5 +51,5 @@
 ostream & ParticleInfo::operator << (ostream &ost) const
 {
-  ost << "[" << name << "|" << this << "]";
+  ost << getName();
   return ost;
 };
Index: src/atom_particleinfo.hpp
===================================================================
--- src/atom_particleinfo.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/atom_particleinfo.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -18,5 +18,6 @@
 #endif
 
-#include <iostream>
+#include <iosfwd>
+#include <string>
 
 /****************************************** forward declarations *****************************/
@@ -31,5 +32,5 @@
   ParticleInfo();
   ParticleInfo(ParticleInfo*);
-  ~ParticleInfo();
+  virtual ~ParticleInfo();
 
   const std::string& getName() const;
Index: src/atom_trajectoryparticle.cpp
===================================================================
--- src/atom_trajectoryparticle.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/atom_trajectoryparticle.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,4 +6,9 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
@@ -12,9 +17,9 @@
 #include "config.hpp"
 #include "element.hpp"
-#include "info.hpp"
-#include "log.hpp"
+#include "Helpers/Info.hpp"
+#include "Helpers/Log.hpp"
 #include "parser.hpp"
 #include "ThermoStatContainer.hpp"
-#include "verbose.hpp"
+#include "Helpers/Verbose.hpp"
 
 /** Constructor of class TrajectoryParticle.
@@ -38,5 +43,5 @@
 {
   for (int i=NDIM;i--;)
-    *temperature += type->mass * Trajectory.U.at(step)[i]* Trajectory.U.at(step)[i];
+    *temperature += getType()->mass * Trajectory.U.at(step)[i]* Trajectory.U.at(step)[i];
 };
 
@@ -65,5 +70,5 @@
   for(int d=0;d<NDIM;d++) {
     Trajectory.U.at(Step)[d] -= CoGVelocity->at(d);
-    *ActualTemp += 0.5 * type->mass * Trajectory.U.at(Step)[d] * Trajectory.U.at(Step)[d];
+    *ActualTemp += 0.5 * getType()->mass * Trajectory.U.at(Step)[d] * Trajectory.U.at(Step)[d];
   }
 };
@@ -113,10 +118,10 @@
     Trajectory.R.at(NextStep)[d] = Trajectory.R.at(NextStep-1)[d];
     Trajectory.R.at(NextStep)[d] += configuration->Deltat*(Trajectory.U.at(NextStep-1)[d]);     // s(t) = s(0) + v * deltat + 1/2 a * deltat^2
-    Trajectory.R.at(NextStep)[d] += 0.5*configuration->Deltat*configuration->Deltat*(Trajectory.F.at(NextStep)[d]/type->mass);     // F = m * a and s =
+    Trajectory.R.at(NextStep)[d] += 0.5*configuration->Deltat*configuration->Deltat*(Trajectory.F.at(NextStep)[d]/getType()->mass);     // F = m * a and s =
   }
   // Update U
   for (int d=0; d<NDIM; d++) {
     Trajectory.U.at(NextStep)[d] = Trajectory.U.at(NextStep-1)[d];
-    Trajectory.U.at(NextStep)[d] += configuration->Deltat * (Trajectory.F.at(NextStep)[d]+Trajectory.F.at(NextStep-1)[d]/type->mass); // v = F/m * t
+    Trajectory.U.at(NextStep)[d] += configuration->Deltat * (Trajectory.F.at(NextStep)[d]+Trajectory.F.at(NextStep-1)[d]/getType()->mass); // v = F/m * t
   }
   // Update R (and F)
@@ -137,7 +142,7 @@
 void TrajectoryParticle::SumUpKineticEnergy( int Step, double *TotalMass, Vector *TotalVelocity ) const
 {
-  *TotalMass += type->mass;  // sum up total mass
+  *TotalMass += getType()->mass;  // sum up total mass
   for(int d=0;d<NDIM;d++) {
-    TotalVelocity->at(d) += Trajectory.U.at(Step)[d]*type->mass;
+    TotalVelocity->at(d) += Trajectory.U.at(Step)[d]*getType()->mass;
   }
 };
@@ -154,5 +159,5 @@
     for (int d=0; d<NDIM; d++) {
       U[d] *= ScaleTempFactor;
-      *ekin += 0.5*type->mass * U[d]*U[d];
+      *ekin += 0.5*getType()->mass * U[d]*U[d];
     }
 };
@@ -170,5 +175,5 @@
     for (int d=0; d<NDIM; d++) {
       *G += U[d] * F[d];
-      *E += U[d]*U[d]*type->mass;
+      *E += U[d]*U[d]*getType()->mass;
     }
 };
@@ -185,6 +190,6 @@
   if (FixedIon == 0) // even FixedIon moves, only not by other's forces
     for (int d=0; d<NDIM; d++) {
-      U[d] += configuration->Deltat/type->mass * ( (G_over_E) * (U[d]*type->mass) );
-      *ekin += type->mass * U[d]*U[d];
+      U[d] += configuration->Deltat/getType()->mass * ( (G_over_E) * (U[d]*getType()->mass) );
+      *ekin += getType()->mass * U[d]*U[d];
     }
 };
@@ -198,5 +203,5 @@
 void TrajectoryParticle::Thermostat_Langevin(int Step, gsl_rng * r, double *ekin, config *configuration)
 {
-  double sigma  = sqrt(configuration->Thermostats->TargetTemp/type->mass); // sigma = (k_b T)/m (Hartree/atomicmass = atomiclength/atomictime)
+  double sigma  = sqrt(configuration->Thermostats->TargetTemp/getType()->mass); // sigma = (k_b T)/m (Hartree/atomicmass = atomiclength/atomictime)
   Vector &U = Trajectory.U.at(Step);
   if (FixedIon == 0) { // even FixedIon moves, only not by other's forces
@@ -211,5 +216,5 @@
     }
     for (int d=0; d<NDIM; d++)
-      *ekin += 0.5*type->mass * U[d]*U[d];
+      *ekin += 0.5*getType()->mass * U[d]*U[d];
   }
 };
@@ -227,5 +232,5 @@
     for (int d=0; d<NDIM; d++) {
       U[d] *= sqrt(1+(configuration->Deltat/configuration->Thermostats->TempFrequency)*(ScaleTempFactor-1));
-      *ekin += 0.5*type->mass * U[d]*U[d];
+      *ekin += 0.5*getType()->mass * U[d]*U[d];
     }
   }
@@ -241,5 +246,5 @@
   if (FixedIon == 0) { // even FixedIon moves, only not by other's forces
     for (int d=0; d<NDIM; d++) {
-      *delta_alpha += U[d]*U[d]*type->mass;
+      *delta_alpha += U[d]*U[d]*getType()->mass;
     }
   }
@@ -256,7 +261,23 @@
   if (FixedIon == 0) { // even FixedIon moves, only not by other's forces
     for (int d=0; d<NDIM; d++) {
-        U[d] += configuration->Deltat/type->mass * (configuration->Thermostats->alpha * (U[d] * type->mass));
-        *ekin += (0.5*type->mass) * U[d]*U[d];
+        U[d] += configuration->Deltat/getType()->mass * (configuration->Thermostats->alpha * (U[d] * getType()->mass));
+        *ekin += (0.5*getType()->mass) * U[d]*U[d];
       }
   }
 };
+
+
+std::ostream & TrajectoryParticle::operator << (std::ostream &ost) const
+{
+  ParticleInfo::operator<<(ost);
+  ost << "," << getPosition();
+  return ost;
+}
+
+std::ostream & operator << (std::ostream &ost, const TrajectoryParticle &a)
+{
+  a.ParticleInfo::operator<<(ost);
+  ost << "," << a.getPosition();
+  return ost;
+}
+
Index: src/atom_trajectoryparticle.hpp
===================================================================
--- src/atom_trajectoryparticle.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/atom_trajectoryparticle.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -20,4 +20,5 @@
 #include <fstream>
 
+#include <gsl/gsl_inline.h>
 #include <gsl/gsl_randist.h>
 
@@ -62,8 +63,10 @@
   void Thermostat_NoseHoover_scale(int Step, double *ekin, config *configuration);
 
+  std::ostream & operator << (std::ostream &ost) const;
+
 private:
-
 };
 
+ostream & operator << (ostream &ost, const TrajectoryParticle &a);
 
 #endif /* ATOM_TRAJECTORYPARTICLE_HPP_ */
Index: src/atom_trajectoryparticleinfo.cpp
===================================================================
--- src/atom_trajectoryparticleinfo.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/atom_trajectoryparticleinfo.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,4 +6,9 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
@@ -12,5 +17,7 @@
 /** Constructor of class TrajectoryParticleInfo.
  */
-TrajectoryParticleInfo::TrajectoryParticleInfo() : FixedIon(0) {};
+TrajectoryParticleInfo::TrajectoryParticleInfo() :
+  FixedIon(0)
+{};
 
 /** Destructor of class TrajectoryParticleInfo.
Index: src/atom_trajectoryparticleinfo.hpp
===================================================================
--- src/atom_trajectoryparticleinfo.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/atom_trajectoryparticleinfo.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -20,6 +20,6 @@
 #include <vector>
 
-#include "vector.hpp"
-#include "VectorSet.hpp"
+#include "LinearAlgebra/Vector.hpp"
+#include "LinearAlgebra/VectorSet.hpp"
 
 /********************************************** declarations *******************************/
@@ -36,5 +36,5 @@
 
   TrajectoryParticleInfo();
-  ~TrajectoryParticleInfo();
+  virtual ~TrajectoryParticleInfo();
 
 private:
Index: src/bond.cpp
===================================================================
--- src/bond.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/bond.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -5,6 +5,13 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
 #include "atom.hpp"
 #include "bond.hpp"
@@ -17,9 +24,16 @@
 /** Empty Constructor for class bond.
  */
-bond::bond()
-  : leftatom(NULL), rightatom(NULL), previous(NULL), next(NULL), HydrogenBond(0),
-    BondDegree(0), nr(-1), Cyclic(false), Type(Undetermined), Used(white)
-{
-};
+bond::bond() :
+  leftatom(NULL),
+  rightatom(NULL),
+  previous(NULL),
+  next(NULL),
+  HydrogenBond(0),
+  BondDegree(0),
+  nr(-1),
+  Cyclic(false),
+  Type(Undetermined),
+  Used(white)
+{};
 
 /** Constructor for class bond, taking right and left bond partner
@@ -29,12 +43,20 @@
  * \param number increasing index
  */
-bond::bond(atom *left, atom *right, const int degree, const int number)
-  : leftatom(left), rightatom(right), previous(NULL), next(NULL), HydrogenBond(0),
-    BondDegree(degree), nr(number), Cyclic(false), Type(Undetermined), Used(white)
+bond::bond(atom *left, atom *right, const int degree, const int number) :
+  leftatom(left),
+  rightatom(right),
+  previous(NULL),
+  next(NULL),
+  HydrogenBond(0),
+  BondDegree(degree),
+  nr(number),
+  Cyclic(false),
+  Type(Undetermined),
+  Used(white)
 {
   if ((left != NULL) && (right != NULL)) {
-    if ((left->type != NULL) && (left->type->Z == 1))
+    if ((left->getType() != NULL) && (left->getType()->Z == 1))
       HydrogenBond++;
-    if ((right->type != NULL) && (right->type->Z == 1))
+    if ((right->getType() != NULL) && (right->getType()->Z == 1))
       HydrogenBond++;
   }
@@ -125,5 +147,5 @@
 double bond::GetDistance() const
 {
-  return (leftatom->node->distance(*rightatom->node));
+  return (leftatom->distance(*rightatom));
 };
 
@@ -133,4 +155,4 @@
 double bond::GetDistanceSquared() const
 {
-  return (leftatom->node->DistanceSquared(*rightatom->node));
+  return (leftatom->DistanceSquared(*rightatom));
 };
Index: src/bondgraph.cpp
===================================================================
--- src/bondgraph.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/bondgraph.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -5,4 +5,9 @@
  *      Author: heber
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Helpers/MemDebug.hpp"
@@ -14,17 +19,22 @@
 #include "bondgraph.hpp"
 #include "element.hpp"
-#include "info.hpp"
-#include "log.hpp"
+#include "Helpers/Info.hpp"
+#include "Helpers/Verbose.hpp"
+#include "Helpers/Log.hpp"
 #include "molecule.hpp"
 #include "parser.hpp"
 #include "periodentafel.hpp"
-#include "vector.hpp"
+#include "LinearAlgebra/Vector.hpp"
+
+const double BondGraph::BondThreshold = 0.4;   //!< CSD threshold in bond check which is the width of the interval whose center is the sum of the covalent radii
 
 /** Constructor of class BondGraph.
  * This classes contains typical bond lengths and thus may be used to construct a bond graph for a given molecule.
  */
-BondGraph::BondGraph(bool IsA) : BondLengthMatrix(NULL), max_distance(0), IsAngstroem(IsA)
-{
-};
+BondGraph::BondGraph(bool IsA) :
+    BondLengthMatrix(NULL),
+    max_distance(0),
+    IsAngstroem(IsA)
+{};
 
 /** Destructor of class BondGraph.
@@ -127,6 +137,6 @@
 
   for (molecule::const_iterator iter = mol->begin(); iter != mol->end(); ++iter) {
-    if ((*iter)->type->CovalentRadius > max_distance)
-      max_distance = (*iter)->type->CovalentRadius;
+    if ((*iter)->getType()->CovalentRadius > max_distance)
+      max_distance = (*iter)->getType()->CovalentRadius;
   }
   max_distance *= 2.;
@@ -144,8 +154,8 @@
 void BondGraph::CovalentMinMaxDistance(BondedParticle * const Walker, BondedParticle * const OtherWalker, double &MinDistance, double &MaxDistance, bool IsAngstroem)
 {
-  MinDistance = OtherWalker->type->CovalentRadius + Walker->type->CovalentRadius;
+  MinDistance = OtherWalker->getType()->CovalentRadius + Walker->getType()->CovalentRadius;
   MinDistance *= (IsAngstroem) ? 1. : 1. / AtomicLengthToAngstroem;
-  MaxDistance = MinDistance + BONDTHRESHOLD;
-  MinDistance -= BONDTHRESHOLD;
+  MaxDistance = MinDistance + BondThreshold;
+  MinDistance -= BondThreshold;
 };
 
@@ -165,8 +175,8 @@
     CovalentMinMaxDistance(Walker, OtherWalker, MinDistance, MaxDistance, IsAngstroem);
   } else {
-    MinDistance = GetBondLength(Walker->type->Z-1, OtherWalker->type->Z-1);
+    MinDistance = GetBondLength(Walker->getType()->Z-1, OtherWalker->getType()->Z-1);
     MinDistance *= (IsAngstroem) ? 1. : 1. / AtomicLengthToAngstroem;
-    MaxDistance = MinDistance + BONDTHRESHOLD;
-    MinDistance -= BONDTHRESHOLD;
+    MaxDistance = MinDistance + BondThreshold;
+    MinDistance -= BondThreshold;
   }
 };
Index: src/bondgraph.hpp
===================================================================
--- src/bondgraph.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/bondgraph.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -18,9 +18,6 @@
 #endif
 
-#include <iostream>
+#include <iosfwd>
 
-/*********************************************** defines ***********************************/
-
-#define BONDTHRESHOLD 0.4   //!< CSD threshold in bond check which is the width of the interval whose center is the sum of the covalent radii
 
 /****************************************** forward declarations *****************************/
@@ -48,4 +45,6 @@
 
 private:
+  static const double BondThreshold;
+
   MatrixContainer *BondLengthMatrix;
   double max_distance;
Index: src/boundary.cpp
===================================================================
--- src/boundary.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/boundary.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -4,6 +4,17 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
+#include "Actions/MoleculeAction/RotateToPrincipalAxisSystemAction.hpp"
+#include "BoundaryPointSet.hpp"
+#include "BoundaryLineSet.hpp"
+#include "BoundaryTriangleSet.hpp"
+#include "CandidateForTesselation.hpp"
+//#include "TesselPoint.hpp"
 #include "World.hpp"
 #include "atom.hpp"
@@ -12,14 +23,19 @@
 #include "config.hpp"
 #include "element.hpp"
-#include "helpers.hpp"
-#include "info.hpp"
+#include "Helpers/helpers.hpp"
+#include "Helpers/Info.hpp"
 #include "linkedcell.hpp"
-#include "log.hpp"
-#include "memoryallocator.hpp"
+#include "Helpers/Verbose.hpp"
+#include "Helpers/Log.hpp"
 #include "molecule.hpp"
 #include "tesselation.hpp"
 #include "tesselationhelpers.hpp"
 #include "World.hpp"
-#include "Plane.hpp"
+#include "LinearAlgebra/Plane.hpp"
+#include "LinearAlgebra/Matrix.hpp"
+#include "Box.hpp"
+
+#include <iostream>
+#include <iomanip>
 
 #include<gsl/gsl_poly.h>
@@ -81,5 +97,5 @@
               if (Neighbour == BoundaryPoints[axis].end()) // make it wrap around
                 Neighbour = BoundaryPoints[axis].begin();
-              DistanceVector = runner->second.second->x - Neighbour->second.second->x;
+              DistanceVector = (runner->second.second->getPosition()) - (Neighbour->second.second->getPosition());
               do { // seek for neighbour pair where it flips
                   OldComponent = DistanceVector[Othercomponent];
@@ -87,5 +103,5 @@
                   if (Neighbour == BoundaryPoints[axis].end()) // make it wrap around
                     Neighbour = BoundaryPoints[axis].begin();
-                  DistanceVector = runner->second.second->x - Neighbour->second.second->x;
+                  DistanceVector = (runner->second.second->getPosition()) - (Neighbour->second.second->getPosition());
                   //Log() << Verbose(2) << "OldComponent is " << OldComponent << ", new one is " << DistanceVector.x[Othercomponent] << "." << endl;
                 } while ((runner != Neighbour) && (fabs(OldComponent / fabs(
@@ -99,5 +115,5 @@
                   //Log() << Verbose(1) << "The pair, where the sign of OtherComponent flips, is: " << *(Neighbour->second.second) << " and " << *(OtherNeighbour->second.second) << "." << endl;
                   // now we have found the pair: Neighbour and OtherNeighbour
-                  OtherVector = runner->second.second->x - OtherNeighbour->second.second->x;
+                  OtherVector = (runner->second.second->getPosition()) - (OtherNeighbour->second.second->getPosition());
                   //Log() << Verbose(1) << "Distances to Neighbour and OtherNeighbour are " << DistanceVector.x[component] << " and " << OtherVector.x[component] << "." << endl;
                   //Log() << Verbose(1) << "OtherComponents to Neighbour and OtherNeighbour are " << DistanceVector.x[Othercomponent] << " and " << OtherVector.x[Othercomponent] << "." << endl;
@@ -167,5 +183,5 @@
     // 3b. construct set of all points, transformed into cylindrical system and with left and right neighbours
     for (molecule::const_iterator iter = mol->begin(); iter != mol->end(); ++iter) {
-      ProjectedVector = (*iter)->x - (*MolCenter);
+      ProjectedVector = (*iter)->getPosition() - (*MolCenter);
       ProjectedVector.ProjectOntoPlane(AxisVector);
 
@@ -182,5 +198,5 @@
       }
     DoLog(1) && (Log() << Verbose(1) << "Inserting " << **iter << ": (r, alpha) = (" << radius << "," << angle << "): " << ProjectedVector << endl);
-      BoundaryTestPair = BoundaryPoints[axis].insert(BoundariesPair(angle, DistancePair (radius, (*iter))));
+      BoundaryTestPair = BoundaryPoints[axis].insert(BoundariesPair(angle, TesselPointDistancePair (radius, (*iter))));
       if (!BoundaryTestPair.second) { // same point exists, check first r, then distance of original vectors to center of gravity
         DoLog(2) && (Log() << Verbose(2) << "Encountered two vectors whose projection onto axis " << axis << " is equal: " << endl);
@@ -193,8 +209,7 @@
           DoLog(2) && (Log() << Verbose(2) << "Keeping new vector due to larger projected distance " << ProjectedVectorNorm << "." << endl);
         } else if (fabs(ProjectedVectorNorm - BoundaryTestPair.first->second.first) < MYEPSILON) {
-          helper = (*iter)->x;
-          helper -= *MolCenter;
+          helper = (*iter)->getPosition() - (*MolCenter);
           const double oldhelperNorm = helper.NormSquared();
-          helper = BoundaryTestPair.first->second.second->x - (*MolCenter);
+          helper = BoundaryTestPair.first->second.second->getPosition() - (*MolCenter);
           if (helper.NormSquared() < oldhelperNorm) {
             BoundaryTestPair.first->second.second = (*iter);
@@ -249,17 +264,17 @@
         {
           Vector SideA, SideB, SideC, SideH;
-          SideA = left->second.second->x - (*MolCenter);
+          SideA = left->second.second->getPosition() - (*MolCenter);
           SideA.ProjectOntoPlane(AxisVector);
           //          Log() << Verbose(1) << "SideA: " << SideA << endl;
 
-          SideB = right->second.second->x -(*MolCenter);
+          SideB = right->second.second->getPosition() -(*MolCenter);
           SideB.ProjectOntoPlane(AxisVector);
           //          Log() << Verbose(1) << "SideB: " << SideB << endl;
 
-          SideC = left->second.second->x - right->second.second->x;
+          SideC = left->second.second->getPosition() - right->second.second->getPosition();
           SideC.ProjectOntoPlane(AxisVector);
           //          Log() << Verbose(1) << "SideC: " << SideC << endl;
 
-          SideH = runner->second.second->x -(*MolCenter);
+          SideH = runner->second.second->getPosition() -(*MolCenter);
           SideH.ProjectOntoPlane(AxisVector);
           //          Log() << Verbose(1) << "SideH: " << SideH << endl;
@@ -669,6 +684,7 @@
   double cellvolume = 0.;
 
-  // transform to PAS
-  mol->PrincipalAxisSystem(true);
+  // transform to PAS by Action
+  Vector MainAxis(0.,0.,1.);
+  MoleculeRotateToPrincipalAxisSystem(MainAxis);
 
   IsAngstroem = configuration->GetIsAngstroem();
@@ -694,5 +710,5 @@
   // sum up the atomic masses
   for (molecule::const_iterator iter = mol->begin(); iter != mol->end(); ++iter) {
-      totalmass += (*iter)->type->mass;
+      totalmass += (*iter)->getType()->mass;
   }
   DoLog(0) && (Log() << Verbose(0) << "RESULT: The summed mass is " << setprecision(10) << totalmass << " atomicmassunit." << endl);
@@ -769,7 +785,7 @@
   int N[NDIM];
   int n[NDIM];
-  double *M =  ReturnFullMatrixforSymmetric(World::getInstance().getDomain());
-  double Rotations[NDIM*NDIM];
-  double *MInverse = InverseMatrix(M);
+  const Matrix &M = World::getInstance().getDomain().getM();
+  Matrix Rotations;
+  const Matrix &MInverse = World::getInstance().getDomain().getMinv();
   Vector AtomTranslations;
   Vector FillerTranslations;
@@ -793,5 +809,4 @@
   // Center filler at origin
   filler->CenterEdge(&Inserter);
-  filler->Center.Zero();
   const int FillerCount = filler->getAtomCount();
   DoLog(2) && (Log() << Verbose(2) << "INFO: Filler molecule has the following bonds:" << endl);
@@ -804,6 +819,5 @@
 
   // calculate filler grid in [0,1]^3
-  FillerDistance = Vector(distance[0], distance[1], distance[2]);
-  FillerDistance.InverseMatrixMultiplication(M);
+  FillerDistance = MInverse * Vector(distance[0], distance[1], distance[2]);
   for(int i=0;i<NDIM;i++)
     N[i] = (int) ceil(1./FillerDistance[i]);
@@ -818,6 +832,5 @@
       for (n[2] = 0; n[2] < N[2]; n[2]++) {
         // calculate position of current grid vector in untransformed box
-        CurrentPosition = Vector((double)n[0]/(double)N[0], (double)n[1]/(double)N[1], (double)n[2]/(double)N[2]);
-        CurrentPosition.MatrixMultiplication(M);
+        CurrentPosition = M * Vector((double)n[0]/(double)N[0], (double)n[1]/(double)N[1], (double)n[2]/(double)N[2]);
         // create molecule random translation vector ...
         for (int i=0;i<NDIM;i++)
@@ -840,27 +853,27 @@
             }
 
-            Rotations[0] =   cos(phi[0])            *cos(phi[2]) + (sin(phi[0])*sin(phi[1])*sin(phi[2]));
-            Rotations[3] =   sin(phi[0])            *cos(phi[2]) - (cos(phi[0])*sin(phi[1])*sin(phi[2]));
-            Rotations[6] =               cos(phi[1])*sin(phi[2])                                     ;
-            Rotations[1] = - sin(phi[0])*cos(phi[1])                                                ;
-            Rotations[4] =   cos(phi[0])*cos(phi[1])                                                ;
-            Rotations[7] =               sin(phi[1])                                                ;
-            Rotations[3] = - cos(phi[0])            *sin(phi[2]) + (sin(phi[0])*sin(phi[1])*cos(phi[2]));
-            Rotations[5] = - sin(phi[0])            *sin(phi[2]) - (cos(phi[0])*sin(phi[1])*cos(phi[2]));
-            Rotations[8] =               cos(phi[1])*cos(phi[2])                                     ;
+            Rotations.set(0,0,  cos(phi[0])            *cos(phi[2]) + (sin(phi[0])*sin(phi[1])*sin(phi[2])));
+            Rotations.set(0,1,  sin(phi[0])            *cos(phi[2]) - (cos(phi[0])*sin(phi[1])*sin(phi[2])));
+            Rotations.set(0,2,              cos(phi[1])*sin(phi[2])                                        );
+            Rotations.set(1,0, -sin(phi[0])*cos(phi[1])                                                    );
+            Rotations.set(1,1,  cos(phi[0])*cos(phi[1])                                                    );
+            Rotations.set(1,2,              sin(phi[1])                                                    );
+            Rotations.set(2,0, -cos(phi[0])            *sin(phi[2]) + (sin(phi[0])*sin(phi[1])*cos(phi[2])));
+            Rotations.set(2,1, -sin(phi[0])            *sin(phi[2]) - (cos(phi[0])*sin(phi[1])*cos(phi[2])));
+            Rotations.set(2,2,              cos(phi[1])*cos(phi[2])                                        );
           }
 
           // ... and put at new position
-          Inserter = (*iter)->x;
+          Inserter = (*iter)->getPosition();
           if (DoRandomRotation)
-            Inserter.MatrixMultiplication(Rotations);
+            Inserter *= Rotations;
           Inserter += AtomTranslations + FillerTranslations + CurrentPosition;
 
           // check whether inserter is inside box
-          Inserter.MatrixMultiplication(MInverse);
+          Inserter *= MInverse;
           FillIt = true;
           for (int i=0;i<NDIM;i++)
             FillIt = FillIt && (Inserter[i] >= -MYEPSILON) && ((Inserter[i]-1.) <= MYEPSILON);
-          Inserter.MatrixMultiplication(M);
+          Inserter *= M;
 
           // Check whether point is in- or outside
@@ -877,7 +890,7 @@
             // copy atom ...
             CopyAtoms[(*iter)->nr] = (*iter)->clone();
-            CopyAtoms[(*iter)->nr]->x = Inserter;
+            (*CopyAtoms[(*iter)->nr]).setPosition(Inserter);
             Filling->AddAtom(CopyAtoms[(*iter)->nr]);
-            DoLog(4) && (Log() << Verbose(4) << "Filling atom " << **iter << ", translated to " << AtomTranslations << ", at final position is " << (CopyAtoms[(*iter)->nr]->x) << "." << endl);
+            DoLog(1) && (Log() << Verbose(1) << "Filling atom " << **iter << ", translated to " << AtomTranslations << ", at final position is " << (CopyAtoms[(*iter)->nr]->getPosition()) << "." << endl);
           } else {
             DoLog(1) && (Log() << Verbose(1) << "INFO: Position at " << Inserter << " is inner point, within boundary or outside of MaxDistance." << endl);
@@ -901,6 +914,4 @@
     delete TesselStruct[(*ListRunner)];
   }
-  delete[](M);
-  delete[](MInverse);
 
   return Filling;
Index: src/boundary.hpp
===================================================================
--- src/boundary.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/boundary.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -1,6 +1,4 @@
 #ifndef BOUNDARY_HPP_
 #define BOUNDARY_HPP_
-
-using namespace std;
 
 /*********************************************** includes ***********************************/
@@ -12,5 +10,5 @@
 
 #include <fstream>
-#include <iostream>
+#include <iosfwd>
 
 // STL headers
@@ -18,8 +16,8 @@
 
 #include "defs.hpp"
+#include "BoundaryMaps.hpp"
 
 /****************************************** forward declarations *****************************/
 
-class atom;
 class BoundaryPointSet;
 class BoundaryLineSet;
@@ -30,19 +28,12 @@
 class MoleculeListClass;
 class Tesselation;
+class TesselPoint;
 class Vector;
 
 /********************************************** definitions *********************************/
 
-#define DEBUG 1
-#define DoSingleStepOutput 0
-#define SingleStepWidth 10
-
-#define DistancePair pair < double, atom* >
-#define DistanceMap multimap < double, atom* >
-#define DistanceTestPair pair < DistanceMap::iterator, bool>
-
-#define Boundaries map <double, DistancePair >
-#define BoundariesPair pair<double, DistancePair >
-#define BoundariesTestPair pair< Boundaries::iterator, bool>
+enum { DEBUG=1 };
+enum { DoSingleStepOutput=0 };
+enum { SingleStepWidth=10 };
 
 /********************************************** declarations *******************************/
@@ -52,5 +43,4 @@
 void FindConvexBorder(const molecule* const mol, Boundaries *BoundaryPts, Tesselation *&TesselStruct, const LinkedCell *LCList, const char *filename);
 Vector* FindEmbeddingHole(MoleculeListClass *mols, molecule *srcmol);
-void FindNextSuitablePoint(class BoundaryTriangleSet *BaseTriangle, class BoundaryLineSet *BaseLine, atom*& OptCandidate, Vector *OptCandidateCenter, double *ShortestAngle, const double RADIUS, LinkedCell *LC);
 bool FindNonConvexBorder(const molecule* const mol, Tesselation *&TesselStruct, const LinkedCell *&LC, const double RADIUS, const char *tempbasename);
 Boundaries *GetBoundaryPoints(const molecule *mol, Tesselation *&TesselStruct);
